/*
 * ascw.c
 *
 * Created: 2023/07/26
 
 * Modified: 2023/12/11
	AZ_eXg̑x̃ftHg12.5HzɕύXidɍphƃ{^Ă25Hzj
 * Author: jh4vaj
	CZXyack.cɏ
 
	PB0: KEY_OUT
	PB1: PWM
	PB2: BTN
	PB3: Key_Dit (LEFT)
	PB4: Key_Dah (RIGHT)
	PB5/ADC0: TONE_FREQ
	
	RpCIvVŁuF_CPU=8000000ULv`邱ƁI
 */ 

#if !(defined(F_CPU) && (F_CPU == 8000000UL))
#error F_CPU shall be defined as 8000000UL !! Please define in Makefile
#endif

#include "ascw.h"

#include <avr/io.h>
#include <avr/cpufunc.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <math.h>

#define OPE_MODE_ASCW			0
#define	OPE_MODE_TEST			1
#define OPE_MODE_YACK			2
#define OPE_MODE_YACK_RESET		3

#define TEST_MODE_STOP			0
#define TEST_MODE_TUNE_1000		1
#define TEST_MODE_TUNE_1500		2
#define TEST_MODE_DOTS			3

#define TEST_DOTS_12R5			0
#define TEST_DOTS_25			1

#define TIMEOUT_TEST_MODE		60	/* eXg[h̘Aԁibj	*/

#define READ_BTN	(PINB & (1 << PB2))
#define READ_LEFT	(PINB & (1 << PB3))
#define READ_RIGHT	(PINB & (1 << PB4))

#define BTN_ON		true
#define BTN_OFF		false

#define	SW_CLICK_NONE		0	/* ĂȂimCYj */
#define	SW_CLICK_SHORT		1	/* Z					*/
#define	SW_CLICK_DOUBLE		2	/* _uNbN			*/
#define	SW_CLICK_LONG		3	/* 					*/

#define SIN_WAVE_PRESCALER	8	/* gp^C}EJE^̃NbN	*/

#define N_WAVE  16				/* ge[u̐ij */

uint8_t wave[N_WAVE];			// ge[u
uint8_t i_wave;					// ge[u̎Qƃ|C^

uint8_t	ope_mode;				// 샂[h
uint8_t	dots_mode_speed;		// AZ_[h̑xi12.5Hz / 25Hzj
bool	tone_out;				// g[o̓tO

volatile uint16_t	tick_sec;
volatile uint16_t	cnt_tick, cnt_tick_ini;

int yack_main(void);



/* ggݒ */
void set_sin_freq(uint16_t freq)
{
	const uint16_t adc_min = (1024 / (22 + 5)) * 23 + 20;	// ADCŏl
	const uint16_t adc_max = 1023;	// ADCől
	const uint16_t freq_min = 500;	// g[gϔ͈͉
	const uint16_t freq_max = 900;	// g[gϔ͈͏
	
	if (freq == 0) {	// ŒRǂŎgݒ
		uint16_t adc_val = ADC;		// ADCl擾
	
		if (adc_val < adc_min) {	// ADClŏl̏ꍇ
			adc_val = adc_min;
		}
	
		freq = freq_max - (((adc_max - adc_val) * (freq_max - freq_min)) / (adc_max - adc_min));
	}
	else {
		if (freq < 100) {
			freq = 100;
		}
		else if (freq > 4000) {
			freq = 4000;
		}
	}
	
	OCR0A = (uint8_t)(((((float)F_CPU / (float)SIN_WAVE_PRESCALER)) / (float)N_WAVE) / (float)freq) - 1;
	cnt_tick_ini = freq;
	cnt_tick = cnt_tick_ini;
}



void ascw_setup() {
	float unit_deg;
	int i;

	/* ADC0EJn */
	ADMUX &= ~((1 << MUX2) | (1 << MUX1) | (1 << MUX0));	// ADC0iPB5jI
	ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADEN);	// ADCvXP[64AADCL
	ADCSRA |= (1 << ADATE) | (1 << ADSC);	// Aϊ[hADCJn
	
			
	DDRB |= (1 << PB0);		// PB0o͂ɐݒ
		
	i_wave = 0;
	
	/* ge[u쐬 */
	unit_deg = (2.0 * 3.141592) / (float)(N_WAVE);

	for (i = 0; i < N_WAVE; i++) {
		//wave[i] = (unsigned int)((((sin(unit_deg * (float)i) + 1.0) / 2.0) * 255.0) + 0.5);
		wave[i] = (unsigned int)((((sin(unit_deg * (float)(i + (N_WAVE - (N_WAVE / 4)))) + 1.0) / 2.0) * 255.0) + 0.5);	  // g`̈ԒႢln߂
	}

	
	/* ^C}^JE^0: go͊ݎݒ */
	TCCR0A = (1 << WGM01);	// CTC[h
	TCCR0B = (1 << CS01);	// vXP[8ŃJEgJn
	//OCR0A = 31;			//((F_CPU / vXP[) / F_INT) - 1; // ݒi32kHzj
	set_sin_freq(0);		// ̓{[Őݒ
	TIMSK |= (1 << OCIE0A);	// OCR0AɈv犄荞ݔ

	/* ^C}^JE^1: gpPWMgݒ */
	DDRB |= (1 << PB1);		// PB1o͂ɐݒ
	TCCR1 |= (1 << PWM1A) | (1 << COM1A1);	// PWM[hAOC1Arvŉ
	TCCR1 |= (1 << CS10);	// vXP[Ȃ
	OCR1C = 255;			// TOPlݒiCPUNbN8MHz̏ꍇAPWMg31.25kHzj
	//OCR1A = OCR1C / 2;	// f[eB50%ɐݒ
	OCR1A = 0;				// f[eB0%iPWMo͒~j

}



/* ݃nh: go */
ISR(TIM0_COMPA_vect) {
	if (tone_out == true) {		
		i_wave++;
	
		if (i_wave >= N_WAVE) {
			i_wave = 0;
			
			if (cnt_tick > 0) {
				cnt_tick--;
			}
			else {
				tick_sec++;
				cnt_tick = cnt_tick_ini;
			}
		}
		
		OCR1A = wave[i_wave];
	}
	else {
		/* go͑Q~ */
		//if (i_wave != (N_WAVE - (N_WAVE / 4))) {	// !(g`łႢ_)
		if (i_wave != 0) {
			i_wave++;
				
			if (i_wave >= N_WAVE) {
				i_wave = 0;
			}
		}
		else {
			TCNT1 = 0;	// F̂΂ŷ߂Ƀg[o͒~̓JE^0ɂĂ
		}				// JEĝ̂~߂ƂămCY肵̂
						// JE^͑点܂
						
		OCR1A = wave[i_wave];
	}	
}



	
bool read_btn_single(void) {
	unsigned int	i, n;
	
	n = 0;
	for (i = 1000; i > 0; i--) {
		if (READ_BTN == 0) {
			n++;
		}
	}
	
	if (n >= 700) {
		return(BTN_ON);
	}
	
	return(BTN_OFF);
}



uint8_t read_btn(void) {
	uint8_t	ret;
	
	ret = SW_CLICK_NONE;
	
	_delay_ms(1);
	
	if (read_btn_single() == BTN_ON) {
		ret = SW_CLICK_SHORT;
		
		_delay_ms(120);							// ŏ̃{^҂

		if (read_btn_single() == BTN_OFF) {		// ̎_ŉĂΒZ_uNbN
			_delay_ms(180);						// _uNbN҂
			
			if (read_btn_single() == BTN_ON) {	// xIɂȂĂ΃_uNbN
				ret = SW_CLICK_DOUBLE;
			}
		}
		else {									// IɂȂςȂȂ̂ŒƔ
			ret = SW_CLICK_LONG;
		}

	}
	
	while (READ_BTN == 0) {};					// {^҂

	return(ret);
}
	
	

void ascw(void) {
	uint8_t			test_mode;
	uint8_t			btn_state;

	uint16_t		i, j;
	const uint16_t	chattering_threshold = 100;

	const int		dit_time = 60;	// NbZ[Wp
	
	test_mode = TEST_MODE_STOP;
	tone_out = false;
	
	ascw_setup();
	sei();
	
	_delay_ms(100);
	
	/* NbZ[W */
	if (ope_mode == OPE_MODE_ASCW) {
		tone_out = true;  _delay_ms(dit_time);
		tone_out = false; _delay_ms(dit_time);
		
		tone_out = true;  _delay_ms(dit_time * 3);
		tone_out = false; _delay_ms(dit_time);
		
		tone_out = true;  _delay_ms(dit_time);
		tone_out = false; _delay_ms(dit_time);
	}
	else {		// ope_mode == OPE_MODE_TEST
		tone_out = true;  _delay_ms(dit_time * 3);
		tone_out = false; _delay_ms(dit_time);

		tone_out = true;  _delay_ms(dit_time);
		tone_out = false; _delay_ms(dit_time);

		tone_out = true;  _delay_ms(dit_time * 3);
		tone_out = false; _delay_ms(dit_time);
	}
	
	tone_out = false;
	
	while (READ_BTN == 0) {}


	while(1) {
		if (ope_mode == OPE_MODE_ASCW) {
			if ((READ_LEFT == 0) || (READ_BTN == 0)) {		// cUiphj{^
				_delay_us(100);
				j = 0;
				for (i = 0; i < (uint16_t)((float)chattering_threshold * 1.4); i++) {
					if ((READ_LEFT == 0) || (READ_BTN == 0)) {
						j++;
					}
					
					if (j >= chattering_threshold) {
						break;
					}
				}
	
				if (j >= chattering_threshold) {
					if (READ_BTN == 0) {
						set_sin_freq(0);	// {^̂ƂgύXt
					}
					tone_out = true;
					PORTB |= (1 << PB0);	// KEY_OUT (PB0) Highɐݒ
				}
			}
		}
		else {		// ope_mode == OPE_MODE_TEST
			if (test_mode == TEST_MODE_STOP) {
				if (READ_LEFT == 0) {			// phcUd
					_delay_us(100);
					j = 0;
					for (i = 0; i < (uint16_t)((float)chattering_threshold * 1.4); i++) {
						if (READ_LEFT == 0) {
							j++;
						}
						
						if (j >= chattering_threshold) {
							break;
						}
					}
					
					if (j >= chattering_threshold) {
						tone_out = true;
						PORTB |= (1 << PB0);	// KEY_OUT (PB0) Highɐݒ
					}
				}
			}
			
			if (READ_BTN == 0) {
				btn_state = read_btn();
				
				if (btn_state != SW_CLICK_NONE) {
					if (test_mode != TEST_MODE_STOP) {
						test_mode = TEST_MODE_STOP;
						set_sin_freq(0);
					}
					else {
						tick_sec = 0;
						
						switch (btn_state) {
							case SW_CLICK_SHORT:
								test_mode = TEST_MODE_DOTS;
								break;
							case SW_CLICK_DOUBLE:
								test_mode = TEST_MODE_TUNE_1000;
								set_sin_freq(1000);
								break;
							case SW_CLICK_LONG:
								test_mode = TEST_MODE_TUNE_1500;
								set_sin_freq(1480);
								break;
							case SW_CLICK_NONE:
							default:
								test_mode = TEST_MODE_STOP;
								break;
						}
					}
				}
			}

	
			switch (test_mode) {
				case TEST_MODE_TUNE_1000:
				case TEST_MODE_TUNE_1500:
					tone_out = true;
					PORTB |= (1 << PB0);	// KEY_OUT (PB0) Highɐݒ
					
					if (tick_sec >= TIMEOUT_TEST_MODE) {
						test_mode = TEST_MODE_STOP;
					}
					
					break;
					
				case TEST_MODE_DOTS:
					tone_out = true;
					PORTB |= (1 << PB0);	// KEY_OUT (PB0) Highɐݒ
					
					if (dots_mode_speed == TEST_DOTS_25) {	// 25Hz
						_delay_ms(16);			// lŌ߂l
						_delay_us(750);
					}
					else {						//12.5Hz
						_delay_ms(36);			// lŌ߂l
					}
				
					tone_out = false;
					PORTB &= ~(1 << PB0);	// KEY_OUT (PB0) Lowɐݒ
					
					if (dots_mode_speed == TEST_DOTS_25) {	// 25Hz
						_delay_ms(7);			// lŌ߂l
						_delay_us(300);
					}
					else {						//12.5Hz
						_delay_ms(26);			// lŌ߂l
						_delay_us(400);
					}

					if (tick_sec >= (TIMEOUT_TEST_MODE / 2))  {
						test_mode = TEST_MODE_STOP;
					}
					
					break;
					
				case TEST_MODE_STOP:
				default:
					break;
			}
			
			_delay_ms(10);
		}



		if ((READ_LEFT != 0) && (READ_BTN != 0) && (test_mode == TEST_MODE_STOP)) {
			tone_out = false;
			PORTB &= ~(1 << PB0);	// KEY_OUT (PB0) Lowɐݒ
			
			if (ope_mode == OPE_MODE_TEST) {
				set_sin_freq(0);	// g[gʏԂɖ߂
			}
		}
	}
}



int main(void) {
	DDRB &= ~((1 << PB2) | (1 << PB3) | (1 << PB4));	// PB2APB3APB4͂ɐݒ
	PORTB |= (1 << PB2) | (1 << PB3) | (1 << PB4);		// PB2APB3APB4̓vAbv
	
	_delay_ms(200);	// CPU҂
	
	ope_mode = OPE_MODE_YACK;
	dots_mode_speed = TEST_DOTS_12R5;
	yack_force_reset = false;

	if ((READ_LEFT == 0) && (READ_RIGHT == 0)) {
		ope_mode = OPE_MODE_YACK_RESET;
	}
	else if (READ_BTN == 0) {
		ope_mode = OPE_MODE_TEST;
		if (READ_LEFT == 0) {
			dots_mode_speed = TEST_DOTS_25;
		}
	}
	else if ((READ_LEFT != 0) && (READ_RIGHT == 0)) {
		ope_mode = OPE_MODE_ASCW;
	}
	else {
		ope_mode = OPE_MODE_YACK;
	}
	
	
	switch (ope_mode) {
		case OPE_MODE_YACK_RESET:
			yack_force_reset = true;
			_delay_ms(300);
		case OPE_MODE_YACK:
			yack_main();	// YACKɐڂi͖߂ĂȂj
			break;
			
		case OPE_MODE_TEST:
		case OPE_MODE_ASCW:
		default:
			ascw();			// ASCWɐڂi͖߂ĂȂj
			break;		
	}
	
	/* ɗG[ */
	while (1) {}
}
